
const modifyOneOfRules = (rules) => {
  return rules.map(rule => {
    if (rule.oneOf instanceof Array) {
      const lastOneOfRule = rule.oneOf[rule.oneOf.length - 1];
      lastOneOfRule.exclude = [
        /\.(js|mjs|jsx|cjs|ts|tsx)$/,
        /\.html$/,
        /\.json$/,
      ];
    }
    return rule;
  })
};

const createFullySpecifiedRule = () => ({
  test: /\.m?js$/,
  resolve: {
    fullySpecified: false,
  },
});

module.exports = {
  webpack: {
    configure: config => ({
      ...config,
      module: {
        ...config.module,
        rules: [
          ...modifyOneOfRules(config.module.rules),
          createFullySpecifiedRule()
        ],
      },
    }),
  },
};